
import java.applet.Applet;
import java.applet.AppletContext;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextComponent;
import java.awt.TextField;

import java.net.MalformedURLException;
import java.net.URL;

/**
 *  GKostRVG Ein Applet zur einfachen Abschtzung der Kosten eines
 *  Zivilprozesses
 *  Version 3.1 - Fehler bei pausch. Auslagen beseitigt
 *  Version 3.2 - USt 19% 
 *@author     Franz Xaver Dimbeck
 *@created    20. Juli 2004
 */
public class GKostRVG
	 extends java.applet.Applet {

	private  java.lang.String    farbe;
	private  int                 a;
	private  java.awt.Color      cFarbe;
	         java.awt.Label      lStreitwert;
	         java.awt.TextField  eStreitwert;
	         java.awt.Checkbox   KlgAnw;
	         java.awt.Checkbox   BklAnw;
	         java.awt.Label      lAuslagen;
	         java.awt.Button     bHilfe;
	         java.awt.TextField  eAuslagen;
	         java.awt.Button     bURL;     //Aufruf der Homepage
	         java.awt.TextArea   tErgebnis;
	         java.awt.Checkbox   chBerufung;
	         java.net.URL        myhome;
	         java.awt.Font       myFont;
	         java.awt.Font       ergFont;
	         java.awt.Font       helpFont;

	/**
	 *  Constructor fr das GKostRVG object
	 */
	public GKostRVG() { }

	/**
	 *  Initialisierung des Applets
	 */
	public void init() {
		super.init();
		try {
			myhome = new URL("http://jurfree.dimbeck.de");
		} catch (java.net.MalformedURLException malformedurlexception) {
			bURL.setLabel("http://jurfree.dimbeck.de");
		}
		myFont = new Font("Helvetica", Font.BOLD, 12);
		ergFont = new Font("Monospaced", 0, 12);
		helpFont = new Font("Helvetica", 0, 11);

	java.awt.Panel  panel  = new Panel();
		panel.setLayout(new GridLayout(4, 1));

		lStreitwert = new Label("Streitwert:");
		lStreitwert.setFont(myFont);
		panel.add(lStreitwert);

		eStreitwert = new TextField();
		panel.add(eStreitwert);

		KlgAnw = new Checkbox("Kl\344ger hat Anwalt");
		KlgAnw.setFont(myFont);
		panel.add(KlgAnw);

		BklAnw = new Checkbox("Beklagter hat Anwalt");
		BklAnw.setFont(myFont);
		panel.add(BklAnw);

		lAuslagen = new Label("Beweisauslagen");
		lAuslagen.setFont(myFont);
		panel.add(lAuslagen);
		eAuslagen = new TextField();
		panel.add(eAuslagen);

		tErgebnis = new TextArea("", 10, 36, TextArea.SCROLLBARS_VERTICAL_ONLY);
		tErgebnis.setFont(ergFont);
		tErgebnis.setBackground(new Color((new Integer(a)).parseInt("FFF8d8", 16)));
		tErgebnis.setForeground(java.awt.Color.blue);

		tErgebnis.setEditable(false);
		panel.add(tErgebnis);
		chBerufung = new Checkbox("Berufung");
		chBerufung.setFont(myFont);
		panel.add(chBerufung);

		bHilfe = new Button("Hilfe");
                                        //leeres Feld neben "Berufung"
		panel.add(bHilfe);
                                        //damit die Auslagen in ne neue Zeile kommen


		bURL = new Button("GKostRVG Ver.3.2 http://jurfree.dimbeck.de");
		bURL.setFont(new Font("Helvetica", 0, 10));
		setLayout(new BorderLayout());
		add("North", panel);
		add("South", bURL);
		add("Center", tErgebnis);

                                        // Applet PARAMS abfragen
		try {
			farbe = getParameter("Farbe");
			cFarbe = new Color((new Integer(a)).parseInt(farbe, 16));
		} catch (java.lang.RuntimeException runtimeexception) {
			cFarbe = java.awt.Color.white;
		}

		setBackground(cFarbe);
		panel.setBackground(cFarbe);
		KlgAnw.setBackground(cFarbe);
		BklAnw.setBackground(cFarbe);
		lStreitwert.setBackground(cFarbe);
		lAuslagen.setBackground(cFarbe);
                                        //	bHilfe.setBackground(cFarbe);
		chBerufung.setBackground(cFarbe);

		a = cFarbe.getRed() + cFarbe.getGreen() + cFarbe.getBlue();
		if (a < 500) {
			setForeground(java.awt.Color.white);
			KlgAnw.setForeground(java.awt.Color.white);
			BklAnw.setForeground(java.awt.Color.white);
			lStreitwert.setForeground(java.awt.Color.white);
			lAuslagen.setForeground(java.awt.Color.white);
			chBerufung.setForeground(java.awt.Color.white);
		}
		rechne();
	}

	/**
	 *  Behandlung der Benutzerinteraktionen
	 *
	 *@param  event  Benutzerinteraktion
	 *@return        true bei definerten Aktionen
	 */
	public boolean handleEvent(java.awt.Event event) {
		if ((event.id == 1001) && (event.target == chBerufung)) {
			if (chBerufung.getState()) {
				KlgAnw.setState(true);
				BklAnw.setState(true);
			}
			rechne();
			return true;
		}
		if ((event.id == 402) && (event.target == eAuslagen)) {
			rechne();
			return true;
		}
		if ((event.id == 1001) && (event.target == KlgAnw)) {
			rechne();
			return true;
		}
		if ((event.id == 1001) && (event.target == BklAnw)) {
			rechne();
			return true;
		}
		if ((event.id == 402) && (event.target == eStreitwert)) {
			rechne();
			return true;
		}
		if ((event.id == 1001) && (event.target == bURL)) {
			getAppletContext().showDocument(myhome, "_blank");
			return true;
		}
		if ((event.id == 1001) && (event.target == bHilfe)) {
		java.lang.String  hText;
			tErgebnis.setFont(helpFont);
			tErgebnis.setBackground(new Color((new Integer(a)).parseInt("FFF8d8", 16)));
			tErgebnis.setForeground(java.awt.Color.blue);

			hText =
				"\tKosten eines Zivilprozesses\n"
				 + "\t- Version 3.3 - Januar 2007 (USt 19%) -\n\n"	
				 + "Berechnet werden die Kosten eines Standardfalles. Die Kosten knnen sich erhhen, z.B. durch Reisekosten des Anwalts, durch Hinzuziehung weiterer Anwlte, durch mehr als einen Auftraggeber auf der Klger- oder Beklagtenseite, durch vorgerichtliche Ttigkeiten, Einigung usw."
				 + "\n\n"
				 + "\tEingaben"
				 + "\n\n\t'Streitwert':"
				 + "\nDer Wert des Gegenstandes, um den prozessiert wird. Bitte in Euro eingeben, ggf. mit Dezimalkomma aber ohne Tausender-Trennpunkt."
				 + "\n\n\t'Klger hat Anwalt':"
				 + "\n\t'Beklagter hat Anwalt':"
				 + "\nMarkieren Sie hier bitte, ob bei der Kostenberechnung kein Anwalt, ein Anwalt oder zwei Anwlte bercksichtigt wedrden sollen."
				 + "\n\n\t'Beweisauslagen':"
				 + "\nGeben Sie hier die zustzlichen Kosten einer etwaigen Beweisaufnahme ein, z.B. Zeugenentschdigungen, Sachverstndigenkosten."
				 + "\n\n\t'Berufung':"
				 + "\nWenn dieses Feld markiert ist, werden die Kosten eines Berufungsverfahrens berechnet."
				 + "\n_____________________________________________"
				 + "\nCopyright \251 1998-2007 Franz Xaver Dimbeck, Erding"
				 + "\n\tFreeware Lizenz GNU GPL"
				;
			tErgebnis.setText(hText);
			return true;
		} else {
			return super.handleEvent(event);
		}
	}

	/**
	 *  wertet die Benutzereingaben aus und berechnet die Kosten
	 */
	public void rechne() {
	double            zht   = 0.0D;        //  Zehntel
	double            d     = 0.0D;        //  Anwaltsgebhr
	double            d1    = 2.5D;        //  RA Gebhrensatz fr 1. Instanz = 2,5: 1,3 Verfahrensgebhr + 1,2 Terminsgebhr
	double            d2    = 0.0D;        //  Anzahl der Anwlte
	double            d3    = 0.0D;        //  Gerichtsgebhr
	double            d4    = 0.0D;        //  Auslagen
	double            d5    = 0.0D;        //  Auslagenpauschale
	double            d6    = 0.0D;        //  Mehrwertsteuer
	double            strw;                //  Streitwert
	java.lang.String  s;                   //  fr Textausgabe

		tErgebnis.setFont(ergFont);
		tErgebnis.setBackground(java.awt.Color.white);
		tErgebnis.setForeground(java.awt.Color.black);

		strw = GKostRVG.getDouble(eStreitwert);
		if (strw < 0.01D) {
			s = "Bitte Streitwert in Euro eingeben";
			tErgebnis.setText(s);
			return;
		}
		lStreitwert.setText("Streitwert (EURO):");
		s = "Streitwert:" + GKostRVG.dbl2str(strw) + "\n";
		if (chBerufung.getState()) {
			s += "2";
		} else {
			s += "1";
		}
		s += ". Instanz, ";

		if (KlgAnw.getState()) {
			d2 = 1.0D;
		}
		if (BklAnw.getState()) {
			d2++;
		}

		if (d2 == 0) {
			s += "ohne Anwlte";
		} else if (d2 == 1) {
			s += "ein Anwalt";
		} else {
			s += "zwei Anwlte";
		}
		s += "\n____________________________________\n\n";

		zht = d1 * d2 * 10D;                  //Zehntel

                                        //Awaltsgebhren berechnen
		d = GebRVG(strw, zht);

                                        // Gerichtsgebhren berechnen
		d3 = GebGkgE(strw, 30);

		if (chBerufung.getState()) {
			d = 2.8 * d / 2.5D;
			d3 *= 4D / 3D;
		}

		d4 = GKostRVG.getDouble(eAuslagen);

		if (d2 > 0.0D) {                      //Auslagenpauschale berechnen
			d5 = (d * 0.2D) / d2;				 // 20%
			if (d5 > 20D) {                      // hchstens 20 EURO
				d5 = 20D;
			}
			d5 *= d2;                            // gesamte Anwaltsgebhren
			d6 = (d + d5) * 0.19D;
			s = s + "Anwaltsgeb\374hren \t" + GKostRVG.dbl2str(d)
				 + "\nAuslagenpauschale";
			if (d2 == 2D) {
				s = s + "n";
			}
			s = s + " \t" + GKostRVG.dbl2str(d5) + "\nMWSt 19%         \t"
				 + GKostRVG.dbl2str(d6) + "\n";
		} else {
			d = 0;
		}
		s = s + "Gerichtsgeb\374hren \t" + GKostRVG.dbl2str(d3) + "\n";
		if (d4 > 0.0) {
			s = s + "Zeugen u Sachverst. \t" + GKostRVG.dbl2str(d4) + "\n";
		}
		s = s + "\t\t\t---------------\nGesamtkosten     \t"
			 + GKostRVG.dbl2str(d + d3 + d5 + d6 + d4);
		tErgebnis.setText(s);                 // Ergebnistext ausgeben
	}

	/**
	 *  Informationen zum Applet
	 *
	 *@return    Informationsstring
	 */
	public java.lang.String getAppletInfo() {
		return "GKostRVG Version 3.2: Kosten eines Zivilprozesses \n - \251 1998-2007 Franz Xaver Dimbeck, Erding \n - Freeware-Lizenz: GNU GPL";
	}

	/**
	 *  string (mit DezimalKomma) in Zahl umwandeln, auf zwei
	 *  Nachkomastellen kaufmnnisch gerundet
	 *
	 *@param  s  der umzuwandelnde String
	 *@return    das Ergebnis, wenn der String nicht in eine Zahl
	 *      umgewandelt werden konnt, w1rd 0.00 zurckgegeben
	 */
	public static double str2dbl(java.lang.String s) {

	double  d;
		try {
			d = java.lang.Double.valueOf(s.replace(',', '.')).doubleValue();
			d = GKostRVG.runde(d);
		} catch (java.lang.NumberFormatException numberformatexception) {
			d = 0.0D;
		}
		return d;
	}

	/**
	 *  Verwandelt Zahl in String mit Dezimalkomma und
	 *  Tausendertrennzeichen, kaufmnnisch gerundet auf zwei
	 *  Nachkommastellen, mit Euro-Zeichen am Ende
	 *
	 *@param  d  Zahl, die umgewandelt werden soll
	 *@return    String mit der formatierten Zahl
	 */
	public static java.lang.String dbl2str(double d) {

	long              l   = (long) java.lang.Math.floor(java.lang.Math.abs(d));
	long              l1  = (long) java.lang.Math.round(
			(java.lang.Math.abs(d) - (double) l) * 100D);
	java.lang.String  s   = java.lang.String.valueOf(l);
	java.lang.String  s1  = java.lang.String.valueOf(l1);
	java.lang.String  s2  = "";
	java.lang.String  s3  = "";
		if (s1.length() < 2) {
			s1 = "0" + s1;
		}

	int               i   = s.length() - 3;
		if (d < 0.0D) {
			s2 = "-";
		}
		if ((l >= 1000L) || (l <= -1000L)) {
			for (; i >= 1; i -= 3) {
				s = s.substring(0, i) + "." + s.substring(i, s.length());
			}
		}
		s3 = s2 + s + "," + s1 + " \u20ac";   //String zusammensetzen, EURO-Zeichen ans Ende
		for (int j = s3.length() - 2; j < 14; ) {
			j = s3.length();
			s3 = " " + s3;
		}
		return s3;
	}

	/**
	 *  rundet kaufmnnisch auf zwei Nachkommastellen
	 *
	 *@param  d  zu rundende Zahl
	 *@return    gerundete Zahl
	 */
	private static double runde(double d) {
		return java.lang.Math.round(d * 100D) / 100D;
	}

	/**
	 *  getDouble(TextFiel) wandelt den Inhalt eines Textfeldes in eine
	 *  Zahl um
	 *
	 *@param  textfield  Textfeld, dessen Ihnhalt ungewandelt werden
	 *      soll>
	 *@return            Zahlenwert (double) des Textfeldinhaltes >
	 */
	private static double getDouble(java.awt.TextField textfield) {
		return str2dbl(textfield.getText());
	}

	/**
	 *  teilgeb: Hilfsfunktion, berechnet die Teilgebhr aus einer
	 *  Gebhrenstufe
	 *
	 *@param  Strw      Streitwert
	 *@param  Untergr   Untergrenze
	 *@param  Obergr    Obergrenze
	 *@param  Schrittw  Schrittweite der Stufen
	 *@param  Erhoeh    Erhhungsbetrag pro Stufe
	 *@return           Teilgebhr
	 */
	private static double teilgeb(double Strw, double Untergr, double Obergr, double Schrittw,
	                              double Erhoeh) {
	double  AnzStufen;
		if (Strw > Obergr) {
			Strw = Obergr;
		}
		Strw -= Untergr;
		if (Strw <= 0.0D) {
			return 0.0D;
		}
		AnzStufen = java.lang.Math.ceil(Strw / Schrittw);
		if ((AnzStufen * Schrittw) > Obergr) {
			AnzStufen--;
		}
		return AnzStufen * Erhoeh;
	}

	/**
	 *  berechnet die Anwaltsgebhr
	 *
	 *@param  Streitw  Streitwert
	 *@param  zehntel  Zehntel (= Faktor * 10)
	 *@return          Gebhr nach RVG
	 */
	public static double GebRVG(double Streitw, double zehntel) {

	double  RAGeb  = 25D;
                                        //== Mindestgebhr
		RAGeb += teilgeb(Streitw, 300D, 1500D, 300D, 20D);
		RAGeb += teilgeb(Streitw, 1500D, 5000D, 500D, 28D);
		RAGeb += teilgeb(Streitw, 5000D, 10000D, 1000D, 37D);
		RAGeb += teilgeb(Streitw, 10000D, 25000D, 3000D, 40D);
		RAGeb += teilgeb(Streitw, 25000D, 50000D, 5000D, 72D);
		RAGeb += teilgeb(Streitw, 50000D, 200000D, 15000D, 77D);
		RAGeb += teilgeb(Streitw, 200000D, 500000D, 30000D, 118D);
		RAGeb += teilgeb(Streitw, 500000D, 1E+020D, 50000D, 150D);
		RAGeb = (zehntel * RAGeb) / 10D;
		if (RAGeb < 10D) {
			RAGeb = 10D;
		}
		RAGeb = runde(RAGeb);
		return RAGeb;
	}

	/**
	 *  Berechnet die Gerichtsgebhr
	 *
	 *@param  Streitw  Streitwert
	 *@param  zehntel  Zehntel
	 *@return          GKG-Gebhr
	 */
	public static double GebGkgE(double Streitw, double zehntel) {

	double  GerGeb  = 25D;
                                        //== Mindestgebhr
		GerGeb += teilgeb(Streitw, 300D, 1500D, 300D, 10D);
		GerGeb += teilgeb(Streitw, 1500D, 5000D, 500D, 8D);
		GerGeb += teilgeb(Streitw, 5000D, 10000D, 1000D, 15D);
		GerGeb += teilgeb(Streitw, 10000D, 25000D, 3000D, 23D);
		GerGeb += teilgeb(Streitw, 25000D, 50000D, 5000D, 29D);
		GerGeb += teilgeb(Streitw, 50000D, 200000D, 15000D, 100D);
		GerGeb += teilgeb(Streitw, 200000D, 500000D, 30000D, 150D);
		GerGeb += teilgeb(Streitw, 500000D, 1E+020D, 50000D, 150D);
		GerGeb = (zehntel * GerGeb) / 10D;
		if (GerGeb < 10D) {
			GerGeb = 10D;
		}
		GerGeb = runde(GerGeb);
		return GerGeb;
	}

}

/*
 *  --------------------------------------
 */

